require 'rake/thread_pool'
require 'set'

class Rake::ThreadPool
  @@instance_collector = Set.new

  class << self
    def all_instances
      return @@instance_collector
    end

    def join_all
      all_instances.each(&:join)
    end
  end

  def add_reference
    @@instance_collector << self
  end

  def remove_reference
    @@instance_collector.delete(self)
  end
end

Rake.application.thread_pool.add_reference
